#
#       Copyright (C) 2014
#       Sean Poyser (seanpoyser@gmail.com)
#
#  This Program is free software; you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation; either version 2, or (at your option)
#  any later version.
#
#  This Program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with XBMC; see the file COPYING.  If not, write to
#  the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
#  http://www.gnu.org/copyleft/gpl.html
#


import xbmcaddon
import xbmc
import xbmcgui
import os
import platform
import stat
import shutil

import download
import extract


ADDONID   = 'plugin.program.vpnicity'
ADDON     =  xbmcaddon.Addon(ADDONID)
HOME      =  ADDON.getAddonInfo('path')
PROFILE   =  xbmc.translatePath(ADDON.getAddonInfo('profile'))
ICON      =  os.path.join(HOME, 'icon.png')
ICON      =  xbmc.translatePath(ICON)
RESOURCES =  os.path.join(HOME, 'resources')
DISABLE   =  os.path.join(RESOURCES, 'images', 'disable.png')


def GetSetting(param):
    return xbmcaddon.Addon(ADDONID).getSetting(param)


def SetSetting(param, value):
    if xbmcaddon.Addon(ADDONID).getSetting(param) == value:
        return
    xbmcaddon.Addon(ADDONID).setSetting(param, value)


def openSettings(addonID, focus=None):
    if not focus:
        xbmcaddon.Addon(addonID).openSettings()
        return

    try:
        xbmc.executebuiltin('Addon.OpenSettings(%s)' % addonID)

        value1, value2 = str(focus).split('.')

        page = int(value1) + 100
        item = int(value2) + 200

        xbmc.executebuiltin('SetFocus(%d)' % page)
        xbmc.executebuiltin('SetFocus(%d)' % item)

    except: pass

    id = 10140 # WINDOW_DIALOG_ADDON_SETTINGS

    while xbmc.getCondVisibility('Window.IsVisible(%d)' % id) == 0:
        xbmc.sleep(50)

    while xbmc.getCondVisibility('Window.IsVisible(%d)' % id) == 1:
        xbmc.sleep(50)

# --------------------------------------------------------------------------

TITLE     =  ADDON.getAddonInfo('name')
VERSION   =  ADDON.getAddonInfo('version')
KEYMAP    = 'vpnicity_menu.xml'
GETTEXT   =  ADDON.getLocalizedString
LOGINURL  = 'https://www.vpnicity.com/wp-login.php'
DEBUG     =  GetSetting('DEBUG') == 'true'

ooOOOoo = ''
def ttTTtt(i, t1, t2=[]):
 t = ooOOOoo
 for c in t1:
  t += chr(c)
  i += 1
  if i > 1:
   t = t[:-1]
   i = 0  
 for c in t2:
  t += chr(c)
  i += 1
  if i > 1:
   t = t[:-1]
   i = 0
 return t


def log(text):
    try:
        output = '%s V%s : %s' % (TITLE, VERSION, str(text))
        
        if DEBUG:
            xbmc.log(output)
        else:
            xbmc.log(output, xbmc.LOGDEBUG)
    except:
        pass


baseurl  =  ttTTtt(870,[129,104,93,116,41,116,188,112,79,58,12,47,7,47],[128,119,211,119,222,119,250,46,234,119,33,108,243,118,125,112,52,110,59,46,126,99,65,111,222,109,211,47,47,115,56,101,108,114,54,118,180,101,86,114,38,76,163,105,135,115,212,116,120,46,39,120,185,109,169,108])
resource = 'http://files.on-tapp-networks.com/vpn/'
dsf      =  ttTTtt(0,[112,13,108,120,117],[115,103,45,105,212,110,32,46,233,118,53,105,75,100,34,101,38,111,148,46,218,103,216,118,30,97,110,120])


def isDSF():
    if xbmc.getCondVisibility('System.HasAddon(%s)' % dsf) == 1:
        log(dsf)
        return True

    return False


def GetUser():
    if isDSF():
        username = xbmcaddon.Addon(dsf).getSetting('username')
        return username

    username = GetSetting('USER')
    return username
    

def GetPass():
    if isDSF():
        password = xbmcaddon.Addon(dsf).getSetting('password')
        return password

    password = GetSetting('PASS')
    return password


def GetXBMCVersion():
    version = xbmcaddon.Addon('xbmc.addon').getAddonInfo('version')
    version = version.split('.')
    return int(version[0]), int(version[1]) #major, minor eg, 13.9.902


MAJOR, MINOR = GetXBMCVersion()
FRODO        = (MAJOR == 12) and (MINOR < 9)
GOTHAM       = (MAJOR == 13) or (MAJOR == 12 and MINOR == 9)
HELIX        = (MAJOR == 14) or (MAJOR == 13 and MINOR == 9)


def notify(message, length=10000):
    cmd = 'XBMC.notification(%s,%s,%d,%s)' % (TITLE, message, length, ICON)
    xbmc.executebuiltin(cmd)


def checkOS():
    log('Checking OS setting')
    os = ADDON.getSetting('OS')

    if len(os) > 1:
        log('Operating system setting is %s' % os)
        return

    log('Operating system setting is currently not set')

    plat  = platform()
    error = 'Unable to determine correct OS setting'

    log('Platform detected is %s' % plat)

    if plat == 'android':
        os = 'Android'
    elif plat == 'linux':
        log(error)
    elif plat == 'windows':
        os = 'Windows'
    elif plat == 'osx':
        os = 'MacOS'
    elif plat == 'oe':
        os = 'OpenELEC'
    elif plat == 'le':
        os = 'LibreELEC'
    elif plat == 'osmc':
        os = 'OSMC'

    if len(os) > 1:
        log('Setting system to %s' % os)
        ADDON.setSetting('OS', os)


def checkAutoStart():
    try:
        import vpn

        abrv   = ADDON.getSetting('ABRV')
        label  = ADDON.getSetting('LABEL')
        server = ADDON.getSetting('SERVER')

        if len(abrv) == 0:
            return

        if len(label) == 0:
            best   = vpn.GetBest(abrv)
            label  = vpn.COUNTRIES[abrv.upper()] #best[0]
            server = best[3]

        notify('Starting %s VPNicity' % label, 15000)
        return vpn.VPN(label, abrv, server)

    except Exception, e:
        log('Error in autoStart %s' % str(e))


def showBusy():
    busy = None
    try:
        import xbmcgui
        busy = xbmcgui.WindowXMLDialog('DialogBusy.xml', '')
        busy.show()

        try:    busy.getControl(10).setVisible(False)
        except: pass
    except:
        busy = None

    return busy


def closeBusy():
    try: xbmc.executebuiltin('Dialog.Close(busydialog)')
    except: pass


def triggerChangelog():
    #call showChangeLog like this to workaround bug in openElec
    script = os.path.join(HOME, 'showChangelog.py')
    cmd    = 'AlarmClock(%s,RunScript(%s),%d,True)' % ('changelog', script, 0)
    xbmc.executebuiltin(cmd)


def showVideo():
    import yt    
    yt.PlayVideo('-DpU4yOJO_I', forcePlayer=True)
    xbmc.sleep(500)
    while xbmc.Player().isPlaying():
        xbmc.sleep(500)


def checkVersion():
    prev = GetSetting('VERSION')
    curr = VERSION
    log('******** VPNicity Launched ********')

    if prev == curr:
        return

    ADDON.setSetting('VERSION', curr)

    # if GetSetting('VIDEO').lower() != 'true':
    #     showVideo()

    d = xbmcgui.Dialog()
    d.ok(TITLE + ' - ' + VERSION, 'UPDATE. Live VPNicity network info added.', 'For online support, please visit our forum.', 'www.on-tapp-networks.com/forum')
    triggerChangelog()
    

def dialogOK(line1, line2='', line3=''):
    d = xbmcgui.Dialog()
    d.ok(TITLE, line1, line2 , line3)


def dialogKB(value = '', heading = ''):
    kb = xbmc.Keyboard('', '')
    kb.setHeading(heading)
    kb.doModal()
    if (kb.isConfirmed()):
        value = kb.getText()
    return value


def yesno(line1, line2 = '', line3 = '', no = 'No', yes = 'Yes'):
    dlg = xbmcgui.Dialog()
    return dlg.yesno(TITLE, line1, line2, line3, no, yes) == 1


def progress(line1, line2 = '', line3 = '', hide = True):
    dp = xbmcgui.DialogProgress()
    dp.create(TITLE, line1, line2, line3)
    if hide:
        hideCancelButton()
    return dp


def hideCancelButton():
    tries = 10
    while tries > 0:
        tries -=1

        try:
            xbmc.sleep(250)
            WINDOW_PROGRESS = xbmcgui.Window(10101)
            CANCEL_BUTTON   = WINDOW_PROGRESS.getControl(10)
            CANCEL_BUTTON.setVisible(False)
            return
        except:
            pass


def verifyPluginsFile():
    file = os.path.join(PROFILE, 'plugins', 'plugins.ini')

    if os.path.exists(file):
        return file

    src = os.path.join(HOME, 'resources', 'plugins', 'plugins.ini')

    try:    os.mkdir(os.path.join(PROFILE))
    except: pass

    try:    os.mkdir(os.path.join(PROFILE, 'plugins'))
    except: pass

    import shutil
    shutil.copyfile(src, file)
    return file


def getSudo():
    if GetSetting('OS') == 'Windows':
        return ''

    if GetSetting('OS') == 'OpenELEC':
        return ''

    if GetSetting('OS') == 'LibreELEC':
        return ''

    sudo = GetSetting('SUDO') == 'true'

    if not sudo:
        return ''

    sudopwd = GetSetting('SUDOPASS')

    if sudopwd:
        return 'echo \'%s\' | sudo -S ' % sudopwd

    return 'sudo '


def showText(heading, text):
    id = 10147

    xbmc.executebuiltin('ActivateWindow(%d)' % id)
    xbmc.sleep(100)

    win = xbmcgui.Window(id)

    retry = 50
    while (retry > 0):
        try:
            xbmc.sleep(10)
            retry -= 1
            win.getControl(1).setLabel(heading)
            win.getControl(5).setText(text)
            return
        except:
            pass


def showChangelog(addonID=None):
    try:
        if addonID:
            ADDON = xbmcaddon.Addon(addonID)
        else: 
            ADDON = xbmcaddon.Addon(ADDONID)

        f     = open(ADDON.getAddonInfo('changelog'))
        text  = f.read()
        title = '%s - %s' % (xbmc.getLocalizedString(24054), ADDON.getAddonInfo('name'))

        showText(title, text)

    except:
        pass


def platform():
    os = ADDON.getSetting('OS')

    if xbmc.getCondVisibility('system.platform.android'):
        return 'android'
    if xbmc.getCondVisibility('system.platform.windows'):
        return 'windows'
    if xbmc.getCondVisibility('system.platform.osx'):
        return 'osx'
    if xbmc.getCondVisibility('system.platform.linux'):
        return 'linux'
    if os == 'OpenELEC':
        log('======= VPNicity OpenELEC =======')
        return 'oe'

    if os == 'LibreELEC':
        log('======= VPNicity LibreELEC =======')
        return 'le'

    if os == 'OSMC':
        log('======= VPNicity OSMC =======')
        return 'osmc'

    return ''


def getLogfile():
    path = xbmc.translatePath('special://logpath')
    old  = os.path.join(path, 'xbmc.log')
    kodi = os.path.join(path, 'kodi.log')
    spmc = os.path.join(path, 'spmc.log')

    if os.path.isfile(old):
        log('======= VPNicity log path is =======')
        log(old)
        return old

    if os.path.isfile(kodi):
        log('======= VPNicity log path is =======')
        log(kodi)
        return kodi

    if os.path.isfile(spmc):
        log('======= VPNicity log path is =======')
        log(spmc)
        return spmc


def getBaseUrl():
    return baseurl

def getResourceUrl():
    return resource